#include "player.hpp"
#include "lib/scn/draw/NodeShape.hpp"

#include "gamescene.hpp"

namespace zoper
{
	Player::Player(const lib::vector2du32 &bPosition, const lib::vector2df &size)
		: GameBaseTile{ 0, size, "player" },
		playerDirection{ Direction::Up }
	{
		auto this_ = getAsEllipseShape();
		this_->setPointCount(3);
		this_->setFillColor(getColorForToken());
		setBoardPosition(bPosition);
	}

	Player::~Player()
	{
	}

	void Player::setBoardPosition(const lib::vector2du32 &np)
	{
		_boardPosition = np;
	}

	void Player::setCurrentDirection(const Direction & direction)
	{
		playerDirection = direction;
	}
}
